﻿Imports USBDevice1.DeviceManagement
Imports USBDevice1.FileIO
Imports USBDevice1.Hid
Imports Microsoft.Win32.SafeHandles
Imports System.Globalization
Imports System.Runtime.InteropServices
Imports System.IO

Public Class Form1

  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    Dim mytime As Date = Now
    Dim success As Boolean
    Dim outputReportBuffer() As Byte = Nothing, inputReportBuffer() As Byte = Nothing
    mytime = mytime.AddMilliseconds(500)

    '      SplashScreen1.Show()     ' gestito in Proprietà


    ToolStripStatusLabel1.Text = "Loading settings"

    Timer1.Interval = 500
    Timer1.Enabled = True

    Ampiezza = 100
    Frequency = 1000
    DutyCycle = 20
    NumericUpDown3.Value = Ampiezza
    NumericUpDown4.Value = Frequency
    NumericUpDown1.Value = DutyCycle

    OpenComm("USB/115F&0242")

    Do
      Application.DoEvents()
    Loop While Now() < mytime
    '        System.Threading.Thread.Sleep(1000)

    '     SplashScreen1.Hide()

    ToolStripStatusLabel1.Text = "Ready"


    If myUSBDeviceDetected Then
      Dim myOutputReport As New Hid.OutputReportViaInterruptTransfer

      Array.Resize(outputReportBuffer, MyHid.Capabilities.OutputReportByteLength)
      ' Store the report ID in the first byte of the buffer:

      outputReportBuffer(0) = 2

      ' Store the report data following the report ID.
      ' Use the data in the combo boxes on the form.

      outputReportBuffer(1) = USB_CMD.CMD_GETID
      success = myOutputReport.Write(outputReportBuffer, writeHandle)
      If (MyHid.Capabilities.InputReportByteLength > 0) Then
        Array.Resize(inputReportBuffer, MyHid.Capabilities.InputReportByteLength)
        Dim ar As IAsyncResult
        Dim myInputReport As New Hid.InputReportViaInterruptTransfer
        Dim MyReadInputReportDelegate As _
            New ReadInputReportDelegate(AddressOf myInputReport.Read)
        ar = MyReadInputReportDelegate.BeginInvoke _
            (hidHandle, readHandle, writeHandle, _
            myUSBDeviceDetected, _
            inputReportBuffer, _
            success, _
            New AsyncCallback(AddressOf GetInputReportData), _
            MyReadInputReportDelegate)
      End If

      outputReportBuffer(1) = USB_CMD.CMD_GETCAPABILITIES
      success = myOutputReport.Write(outputReportBuffer, writeHandle)
      If (MyHid.Capabilities.InputReportByteLength > 0) Then
        Array.Resize(inputReportBuffer, MyHid.Capabilities.InputReportByteLength)
        Dim ar As IAsyncResult
        Dim myInputReport As New Hid.InputReportViaInterruptTransfer
        Dim MyReadInputReportDelegate As _
            New ReadInputReportDelegate(AddressOf myInputReport.Read)
        ar = MyReadInputReportDelegate.BeginInvoke _
            (hidHandle, readHandle, writeHandle, _
            myUSBDeviceDetected, _
            inputReportBuffer, _
            success, _
            New AsyncCallback(AddressOf GetInputReportData), _
            MyReadInputReportDelegate)
      End If

      Button1.Enabled = True
      'NumericUpDown1.Enabled = True
      NumericUpDown3.Enabled = True
      NumericUpDown4.Enabled = True

    End If

    'updateWave() ' cmq
    do_timer = True

  End Sub

  Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    Dim i As Integer

    do_timer = False

    If myUSBDeviceDetected Then
      If Not hidHandle Is Nothing Then
        If Not hidHandle.IsInvalid Then
          hidHandle.Close()
        End If
      End If

      If Not readHandle Is Nothing Then
        If Not readHandle.IsInvalid Then
          readHandle.Close()
        End If
      End If

      If Not writeHandle Is Nothing Then
        If Not writeHandle.IsInvalid Then
          writeHandle.Close()
        End If
      End If

      ' Stop receiving notifications.
      '            MyDeviceManagement.StopReceivingDeviceNotifications(deviceNotificationHandle)
    End If


    My.Settings.Save()
  End Sub

  Private Sub MyMarshalToForm(ByVal action As String, ByVal textToDisplay As String)
    Dim args() As Object = {action, textToDisplay}
    Dim MarshalToFormDelegate As MarshalToForm

    ' The AccessForm routine contains the code that accesses the form.
    MarshalToFormDelegate = New MarshalToForm(AddressOf AccessForm)

    ' Execute AccessForm, passing the parameters in args.
    MyBase.Invoke(MarshalToFormDelegate, args)
  End Sub
  ''' <summary>
  ''' Called when a WM_DEVICECHANGE message has arrived,
  ''' indicating that a device has been attached or removed.
  ''' </summary>
  ''' 
  ''' <param name="m"> a message with information about the device </param>

  Friend Sub OnDeviceChange(ByVal m As Message)

    'Debug.WriteLine("WM_DEVICECHANGE")

    Try
      If (m.WParam.ToInt32 = DBT_DEVICEARRIVAL) Then

        ' If WParam contains DBT_DEVICEARRIVAL, a device has been attached.
        'Debug.WriteLine("A device has been attached.")

        ' Find out if it's the device we're communicating with.
        If MyDeviceManagement.DeviceNameMatch(m, myDevicePathName) Then
          'lstResults.Items.Add("My device attached.")
        End If

      ElseIf (m.WParam.ToInt32 = DBT_DEVICEREMOVECOMPLETE) Then

        ' If WParam contains DBT_DEVICEREMOVAL, a device has been removed.
        'Debug.WriteLine("A device has been removed.")

        ' Find out if it's the device we're communicating with.
        If MyDeviceManagement.DeviceNameMatch(m, myDevicePathName) Then

          'lstResults.Items.Add("My device removed.")

          ' Set MyDeviceDetected False so on the next data-transfer attempt,
          ' FindTheHid() will be called to look for the device 
          ' and get a new handle.

          myUSBDeviceDetected = False
        End If
      End If

      '            ScrollToBottomOfListBox()

    Catch ex As Exception
      DisplayException(Me.Name, ex)
      Throw
    End Try
  End Sub


  ''' <summary>
  ''' In asynchronous ReadFiles, the callback function GetInputReportData
  ''' uses this routine to access the application's form, which runs in 
  ''' a different thread.
  ''' The routine performs various application-specific functions that
  ''' involve accessing the application's form.
  ''' </summary>
  ''' 
  ''' <param name="action"> a string that names the action to perform on the form</param>
  ''' <param name="formText"> text that the form displays or the code uses for 
  ''' another purpose. Actions that don't use text ignore this parameter. </param>

  Private Sub AccessForm(ByVal action As String, ByVal formText As String)
    Dim strFormat As String

    Try
      ' Select an action to perform on the form:

      Select Case action
        Case "AddItemToListBox"

        Case "ProgressBar1"
          '          ProgressBar1.Value = IIf(Val(formText) > 0, 10, 0)

        Case "Stato"
          If Val(formText) Then
            Label3.Text = "Locked"
            Label3.ForeColor = Color.Green
          Else
            Label3.Text = "Not locked"
            Label3.ForeColor = Color.Red
          End If

        Case "CheckBox1"

        Case "TextBox1"
          TextBox1.Text = formText

        Case "TextBox11"
          '         TextBox1.Text += CStr(Val(formText) / 1024 / 8) + "KB"

        Case "TextBox2"
          strFormat = "#0.0"

        Case "TextBox3"
          strFormat = "0.0"
        Case "TextBox4"
        Case "TextBox5"

        Case "NumericUpDown4"

        Case "NumericUpDown3"

        Case "EnableCmdOnce"
          ' If it's a single transfer, re-enable the command button.

        Case "ScrollToBottomOfListBox"


        Case "TextBoxSelectionStart"

        Case Else
          If action = "Text601" Then
            '                        TextBox601.Text = formText
          End If

      End Select

    Catch ex As Exception
      DisplayException(Me.Name, ex)
      Throw
    End Try

  End Sub


  ''' <summary>
  ''' Retrieves Input report data and status information.
  ''' This routine is called automatically when myInputReport.Read
  ''' returns. Calls several marshaling routines to access the main form.
  ''' </summary>
  ''' 
  ''' <param name="ar"> an object containing status information about 
  ''' the asynchronous operation. </param>

  Private Sub GetInputReportData(ByVal ar As IAsyncResult)

    Dim byteValue As String
    Dim count As Int32
    Dim inputReportBuffer As Byte() = Nothing
    Dim success As Boolean

    Try
      'Define a delegate using the IAsyncResult object.

      Dim deleg As ReadInputReportDelegate = _
          DirectCast(ar.AsyncState, ReadInputReportDelegate)

      ' Get the IAsyncResult object and the values of other paramaters that the
      ' BeginInvoke method passed ByRef.

      deleg.EndInvoke(myUSBDeviceDetected, inputReportBuffer, success, ar)

      ' Display the received report data in the form's list box.

      If (ar.IsCompleted And success) Then

        Dim ch As String, i As Integer, s As String

        Select Case inputReportBuffer(1)
          Case USB_CMD.CMD_GETID      ' copyright string
            i = 2
            s = ""
            Do
              If inputReportBuffer(i) <> 0 Then
                ch = Chr(inputReportBuffer(i))
                s += ch
              Else
                MyMarshalToForm("TextBox1", s)
                Exit Do
              End If

              i += 1
            Loop Until i >= 64

          Case USB_CMD.CMD_GETSTATUS      ' status
            Stato = inputReportBuffer(4)
            'opzioni = MAKEWORD(inputReportBuffer(4), inputReportBuffer(5))

            MyMarshalToForm("Stato", Stato)
            '            MyMarshalToForm("TextBox2", VoltageRead)

          Case USB_CMD.CMD_GETCAPABILITIES      ' config
            '            MyMarshalToForm("TextBox2", MemorySize)
 
        End Select


      Else
        'MyMarshalToForm("AddItemToListBox", "The attempt to read an Input report has failed.")
        'Debug.Write("The attempt to read an Input report has failed")
      End If

      'MyMarshalToForm("ScrollToBottomOfListBox", "")

      ' Enable requesting another transfer.
      'MyMarshalToForm("EnableCmdOnce", "")

    Catch ex As Exception
      DisplayException(Me.Name, ex)
      Throw
    End Try

  End Sub

  Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
    Dim success As Boolean
    Dim inputReportBuffer() As Byte = Nothing
    Dim outputReportBuffer() As Byte = Nothing

    If Not do_timer Then
      Exit Sub
    End If

    If myUSBDeviceDetected Then
      Dim myOutputReport As New Hid.OutputReportViaInterruptTransfer

      Array.Resize(outputReportBuffer, MyHid.Capabilities.OutputReportByteLength)
      ' Store the report ID in the first byte of the buffer:

      outputReportBuffer(0) = 2

      ' Store the report data following the report ID.
      ' Use the data in the combo boxes on the form.

      outputReportBuffer(1) = USB_CMD.CMD_GETSTATUS
      success = myOutputReport.Write(outputReportBuffer, writeHandle)
    End If

    If success Then
      ToolStripStatusLabel1.Text = "An Output report has been written."

      'Next count
      ' Read an Input report.

      success = False

      ' Don't attempt to send an Input report if the HID has no Input report.
      ' (The HID spec requires all HIDs to have an interrupt IN endpoint,
      ' which suggests that all HIDs must support Input reports.)

      If (MyHid.Capabilities.InputReportByteLength > 0) Then

        ' Set the size of the Input report buffer. 
        ' Subtract 1 from the value in the Capabilities structure because 
        ' the array begins at index 0.

        'ReDim inputReportBuffer(MyHid.Capabilities.InputReportByteLength - 1)
        Array.Resize(inputReportBuffer, MyHid.Capabilities.InputReportByteLength)

        ' Read a report using interrupt transfers.                
        ' To enable reading a report without blocking the main thread, this
        ' application uses an asynchronous delegate.

        Dim ar As IAsyncResult
        Dim myInputReport As New Hid.InputReportViaInterruptTransfer

        ' Define a delegate for the Read method of myInputReport.

        Dim MyReadInputReportDelegate As _
            New ReadInputReportDelegate(AddressOf myInputReport.Read)

        ' The BeginInvoke method calls myInputReport.Read to attempt to read a report.
        ' The method has the same parameters as the Read function,
        ' plus two additional parameters:
        ' GetInputReportData is the callback procedure that executes when the Read function returns.
        ' MyReadInputReportDelegate is the asynchronous delegate object.
        ' The last parameter can optionally be an object passed to the callback.

        ar = MyReadInputReportDelegate.BeginInvoke _
            (hidHandle, readHandle, writeHandle, _
            myUSBDeviceDetected, _
            inputReportBuffer, _
            success, _
            New AsyncCallback(AddressOf GetInputReportData), _
            MyReadInputReportDelegate)

      Else
        ToolStripStatusLabel1.Text = "No attempt to read an Input report was made."
        'lstResults.Items.Add("The HID doesn't have an Input report.")
      End If


    Else
      ToolStripStatusLabel1.Text = "The attempt to write an Output report has failed."


    End If

  End Sub




  Private Sub InformazioniSuGDsPowerSupplyToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InformazioniSuGDsPowerSupplyToolStripMenuItem.Click
    SplashScreen1.Button1.Visible = True
    SplashScreen1.ShowDialog(Me)
  End Sub

  Private Sub NumericUpDown4_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown4.ValueChanged, NumericUpDown4.Leave

    '    If NumericUpDown4.Value >= 0 And NumericUpDown4.Value <= 30 Then    ' v. anche propr. oggetto
    Frequency = NumericUpDown4.Value
    'End If

    If ComboBox1.SelectedIndex = -1 Then
      '      ComboBox1.SelectedIndex = 1
    End If
    sendSetReport()

  End Sub
  Private Sub NumericUpDown4_KeyPress(sender As System.Object, e As System.Windows.Forms.KeyPressEventArgs) Handles NumericUpDown4.KeyPress
    NumericUpDown4_ValueChanged(sender, e)
  End Sub

  Private Sub NumericUpDown3_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown3.ValueChanged
    'updateWave()
    PictureBox1.Invalidate()

    If NumericUpDown3.Value >= 0 And NumericUpDown3.Value <= 3 Then   ' v. anche propr. oggetto
      '      MaxAmpere = NumericUpDown3.Value * 10
    End If
    Ampiezza = NumericUpDown3.Value
    NumericUpDown4_ValueChanged(sender, e)
  End Sub

  Private Sub NumericUpDown1_ValueChanged(sender As System.Object, e As System.EventArgs) Handles NumericUpDown1.ValueChanged
    '    updateWave()
    DutyCycle = NumericUpDown1.Value
    PictureBox1.Invalidate()

    NumericUpDown4_ValueChanged(sender, e)

  End Sub

  Public Function sendSetReport()
    Dim success As Boolean, n As UInt32
    Dim outputReportBuffer() As Byte = Nothing, inputReportBuffer() As Byte = Nothing

    If myUSBDeviceDetected Then
      Dim myOutputReport As New Hid.OutputReportViaInterruptTransfer

      Array.Resize(outputReportBuffer, MyHid.Capabilities.OutputReportByteLength)
      ' Store the report ID in the first byte of the buffer:

      outputReportBuffer(0) = 2

      ' Store the report data following the report ID.
      ' Use the data in the combo boxes on the form.

      outputReportBuffer(1) = USB_CMD.CMD_SETFUNCTION
      outputReportBuffer(2) = 0
      outputReportBuffer(3) = 0      ' 
      outputReportBuffer(8) = ComboBox1.SelectedIndex
      n = DutyCycle * 10
      outputReportBuffer(10) = LOBYTE(n)
      outputReportBuffer(11) = HIBYTE(n)   '
      n = Frequency * 10
      outputReportBuffer(12) = LOBYTE(LOWORD(n))
      outputReportBuffer(13) = HIBYTE(LOWORD(n))
      outputReportBuffer(14) = LOBYTE(HIWORD(n))
      outputReportBuffer(15) = HIBYTE(HIWORD(n))
      outputReportBuffer(16) = Ampiezza


      success = myOutputReport.Write(outputReportBuffer, writeHandle)
      If (MyHid.Capabilities.InputReportByteLength > 0) Then
        Array.Resize(inputReportBuffer, MyHid.Capabilities.InputReportByteLength)
        Dim ar As IAsyncResult
        Dim myInputReport As New Hid.InputReportViaInterruptTransfer
        Dim MyReadInputReportDelegate As _
            New ReadInputReportDelegate(AddressOf myInputReport.Read)
        ar = MyReadInputReportDelegate.BeginInvoke _
            (hidHandle, readHandle, writeHandle, _
            myUSBDeviceDetected, _
            inputReportBuffer, _
            success, _
            New AsyncCallback(AddressOf GetInputReportData), _
            MyReadInputReportDelegate)
      End If
    End If

    If success Then
      ToolStripStatusLabel1.Text = "A SET Output report has been written."
    End If

    sendSetReport = success
  End Function

  Private Sub ComboBox1_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
    TipoOnda = ComboBox1.SelectedIndex
    If TipoOnda = 5 Then
      NumericUpDown1.Enabled = True
    Else
      NumericUpDown1.Enabled = False
    End If
    PictureBox1.Invalidate()
    '    formGraphics = PictureBox1.CreateGraphics()
    'updateWave()
    NumericUpDown4_ValueChanged(sender, e)
  End Sub

  Private Sub updateWave(ByVal g As Graphics) ' METTERE in Paint!
    '   Dim formGraphics As System.Drawing.Graphics
    Dim xOrg As Integer, yOrg As Integer, xSize As Integer, ySize As Integer
    Dim x As Integer, y As Integer, n As Integer, n2 As Integer, n3 As Integer, n4 As Integer
    Dim myBrush As New System.Drawing.SolidBrush(System.Drawing.Color.White)
    Dim myBrush2 As New System.Drawing.SolidBrush(System.Drawing.Color.Gainsboro)
    Dim myBrush3 As New System.Drawing.SolidBrush(System.Drawing.Color.Black)
    Dim myPen As New System.Drawing.Pen(System.Drawing.Color.DarkGreen)
    Dim myPenGray As New System.Drawing.Pen(System.Drawing.Color.Gray)
    Dim myPenGreen As New System.Drawing.Pen(System.Drawing.Color.LightGreen)
    Dim mycolor As New System.Drawing.Color
    ' Create font and brush.
    Dim drawFont As New Font("Arial", 9)
    Dim drawBrush As New SolidBrush(Color.Black)

    '    formGraphics = Me.CreateGraphics()

    '    xOrg = 620 : yOrg = 60 : xSize = 240 : ySize = 180
    xOrg = 5 : yOrg = 5 : xSize = PictureBox1.Size.Width - 10 : ySize = PictureBox1.Size.Height - 10


    '      formGraphics.FillRectangle(myBrush, New Rectangle(xOrg, yOrg, xSize, ySize))
    '      formGraphics.DrawLine(myPen, New Point(xOrg + 4, yOrg + ySize - 5), New Point(xOrg + xSize - 5, yOrg + ySize - 5))
    '      formGraphics.DrawLine(myPen, New Point(xOrg + 5, yOrg + 5), New Point(xOrg + 5, yOrg + ySize - 4))

    g.FillRectangle(myBrush3, New Rectangle(0, 0, PictureBox1.Size.Width, PictureBox1.Size.Height))
    g.DrawLine(myPen, New Point(xOrg, PictureBox1.Size.Height / 2), New Point(xSize, PictureBox1.Size.Height / 2))
    g.DrawLine(myPen, New Point(PictureBox1.Size.Width / 2, yOrg), New Point(PictureBox1.Size.Width / 2, ySize))

    Dim oldY As Integer
    Select Case TipoOnda
      Case TIPO_ONDA.NESSUNA

      Case TIPO_ONDA.QUADRA
        y = ySize / 2 : oldY = y
        n = xSize - xOrg - 5 : n2 = Int(n / 8)
        For x = 6 To n
          g.DrawLine(myPenGreen,
                                New Point(xOrg + x - 1, oldY),
                                New Point(xOrg + x, IIf(y = 0, yOrg + 5, ySize - 5)))
          oldY = IIf(y = 0, yOrg + 5, ySize - 5)
          If (x Mod n2) = 0 Then
            y = IIf(y = 0, 1, 0)
          End If
        Next

      Case TIPO_ONDA.SINUSOIDALE
        y = ySize / 2 : oldY = y
        n = xSize - xOrg - 5
        For x = 6 To n
          y = ((Math.Sin(x * 6 / xSize * Math.PI) * (ySize - 10)) / 2) + (ySize / 2)
          g.DrawLine(myPenGreen,
                                New Point(xOrg + x - 1, oldY),
                                New Point(xOrg + x, y))
          oldY = y
        Next

      Case TIPO_ONDA.TRIANGOLARE
        y = ySize / 2 : oldY = y
        n = xSize - xOrg - 5 : n2 = Int(n / 8) : n3 = 0 : n4 = 1
        For x = 6 To n
          y = ySize - (n3 / n2 * (ySize - 10)) - 5
          g.DrawLine(myPenGreen,
                                New Point(xOrg + x - 1, oldY),
                                New Point(xOrg + x, y))
          oldY = y
          If n4 Then
            n3 += 1
            If n3 >= n2 Then
              n4 = 0
            End If
          Else
            n3 -= 1
            If n3 = 0 Then
              n4 = 1
            End If
          End If
        Next

      Case TIPO_ONDA.SAWTOOTH
        y = ySize / 2 : oldY = y
        n = xSize - xOrg - 5 : n2 = Int(n / 5) : n3 = 0
        For x = 6 To n
          y = ySize - (n3 / n2 * (ySize - 10)) - 5
          g.DrawLine(myPenGreen,
                                New Point(xOrg + x - 1, oldY),
                                New Point(xOrg + x, y))
          oldY = y
          n3 += 1
          If n3 >= n2 Then
            n3 = 0
          End If
        Next

      Case TIPO_ONDA.IMPULSI
        y = ySize / 2 : oldY = y
        n = xSize - xOrg - 5 : n2 = Int(n / 5) : n3 = 0
        For x = 6 To n
          g.DrawLine(myPenGreen,
                                New Point(xOrg + x - 1, oldY),
                                New Point(xOrg + x, IIf(y = 0, yOrg + 5, ySize - 5)))
          oldY = IIf(y = 0, yOrg + 5, ySize - 5)
          n3 += 1
          y = IIf(n3 >= ((n2 * DutyCycle) / 100), 1, 0)
          If n3 >= n2 Then
            n3 = 0
          End If
        Next

      Case TIPO_ONDA.RUMORE_BIANCO
        y = ySize / 2 : oldY = y
        n = xSize - xOrg - 5
        For x = 6 To n
          If x Mod 2 Then
            y = Rnd() * ySize + yOrg - 10
          End If
          g.DrawLine(myPenGreen,
                                New Point(xOrg + x - 1, oldY),
                                New Point(xOrg + x, y))
          oldY = y
        Next

      Case TIPO_ONDA.RUMORE_ROSA
        y = ySize / 2 : oldY = y
        n = xSize - xOrg - 5
        For x = 6 To n
          If x Mod 2 Then
            y = Rnd() * ySize + yOrg - 10
          End If
          g.DrawLine(myPenGreen,
                                New Point(xOrg + x - 1, oldY),
                                New Point(xOrg + x, y))
          oldY = y
        Next


    End Select
    'formGraphics.FillRectangle(myBrush2, New Rectangle(0, 0, 60, ySize))
    'formGraphics.DrawString("Curva: " + CStr(0), drawFont, drawBrush, New Point(10, ySize - 270))

  End Sub

  Private Sub PictureBox1_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
    updateWave(e.Graphics)
  End Sub

  Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
    Dim success As Boolean, n As UInt32
    Dim outputReportBuffer() As Byte = Nothing, inputReportBuffer() As Byte = Nothing

    If myUSBDeviceDetected Then
      Dim myOutputReport As New Hid.OutputReportViaInterruptTransfer

      Array.Resize(outputReportBuffer, MyHid.Capabilities.OutputReportByteLength)
      ' Store the report ID in the first byte of the buffer:

      outputReportBuffer(0) = 2

      ' Store the report data following the report ID.
      ' Use the data in the combo boxes on the form.

      outputReportBuffer(1) = USB_CMD.CMD_WRITEEEPROM
      outputReportBuffer(3) = 0
      outputReportBuffer(4) = 0      ' salva parametri, fisso!

      success = myOutputReport.Write(outputReportBuffer, writeHandle)
      If (MyHid.Capabilities.InputReportByteLength > 0) Then
        Array.Resize(inputReportBuffer, MyHid.Capabilities.InputReportByteLength)
        Dim ar As IAsyncResult
        Dim myInputReport As New Hid.InputReportViaInterruptTransfer
        Dim MyReadInputReportDelegate As _
            New ReadInputReportDelegate(AddressOf myInputReport.Read)
        ar = MyReadInputReportDelegate.BeginInvoke _
            (hidHandle, readHandle, writeHandle, _
            myUSBDeviceDetected, _
            inputReportBuffer, _
            success, _
            New AsyncCallback(AddressOf GetInputReportData), _
            MyReadInputReportDelegate)
      End If
    End If

    If success Then
      ToolStripStatusLabel1.Text = "A WRITEEEPROM Output report has been written."
    End If

  End Sub

  
  Private Sub PasteToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles PasteToolStripMenuItem.Click
    Dim o As Object, s As String, str As String


    If Clipboard.ContainsData(DataFormats.Text) Then
      o = Clipboard.GetData(DataFormats.Text)


      str = o
      Frequency = Val(str)
      NumericUpDown4.Value = Frequency
    End If

  End Sub

  Private Sub CopyToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles CopyToolStripMenuItem.Click
    Dim o As Object, str As String

    str = Frequency.ToString()

    o = str

    Clipboard.SetData(DataFormats.Text, o)
  End Sub

  Private Sub ResetToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles ResetToolStripMenuItem.Click
    Dim success As Boolean, n As UInt32
    Dim outputReportBuffer() As Byte = Nothing, inputReportBuffer() As Byte = Nothing

    If myUSBDeviceDetected Then
      Dim myOutputReport As New Hid.OutputReportViaInterruptTransfer

      Array.Resize(outputReportBuffer, MyHid.Capabilities.OutputReportByteLength)
      ' Store the report ID in the first byte of the buffer:

      outputReportBuffer(0) = 2

      ' Store the report data following the report ID.
      ' Use the data in the combo boxes on the form.

      outputReportBuffer(1) = USB_CMD.CMD_RESET_IF
      ' o READ EEPROM e setwave
      outputReportBuffer(3) = 0
      outputReportBuffer(4) = 0      ' salva parametri, fisso!

      success = myOutputReport.Write(outputReportBuffer, writeHandle)
      If (MyHid.Capabilities.InputReportByteLength > 0) Then
        Array.Resize(inputReportBuffer, MyHid.Capabilities.InputReportByteLength)
        Dim ar As IAsyncResult
        Dim myInputReport As New Hid.InputReportViaInterruptTransfer
        Dim MyReadInputReportDelegate As _
            New ReadInputReportDelegate(AddressOf myInputReport.Read)
        ar = MyReadInputReportDelegate.BeginInvoke _
            (hidHandle, readHandle, writeHandle, _
            myUSBDeviceDetected, _
            inputReportBuffer, _
            success, _
            New AsyncCallback(AddressOf GetInputReportData), _
            MyReadInputReportDelegate)
      End If
    End If

    If success Then
      ToolStripStatusLabel1.Text = "A RESET Output report has been written."
    End If

  End Sub
End Class

